'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _LocaleProvider = require('./LocaleProvider');

var _LocaleProvider2 = _interopRequireDefault(_LocaleProvider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LocaleSwitch = (_temp = _class = function (_Component) {
  _inherits(LocaleSwitch, _Component);

  function LocaleSwitch() {
    _classCallCheck(this, LocaleSwitch);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(LocaleSwitch).apply(this, arguments));
  }

  _createClass(LocaleSwitch, [{
    key: 'handleChange',
    value: function handleChange(evn) {
      evn.stopPropagation();

      var _props = this.props;
      var locales = _props.locales;
      var onChange = _props.onChange;
      var onError = _props.onError;
      var setLocale = _props.setLocale;

      var translate = this.context.translate;

      var value = evn.target.value;

      for (var index = 0; index < locales.length; index++) {
        var _locales$index = locales[index];
        var locale = _locales$index.locale;
        var label = _locales$index.label;

        if (locale !== value) {
          continue;
        }

        if (setLocale && !translate.props.controlled) {
          translate.setLocale(locale, function (err) {
            if (err && onError) {
              onError(err);
            }
          });
        }

        if (onChange) {
          onChange(locale);
        }

        return;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var translate = this.context.translate;
      var locale = translate.getLocale();
      var locales = this.props.locales;


      var selectProps = _extends({}, this.props);

      delete selectProps.setLocale;
      delete selectProps.locales;

      return _react2.default.createElement(
        'select',
        _extends({}, selectProps, {
          value: locale,
          onChange: this.handleChange.bind(this) }),
        locales.map(function (option, pos) {
          return _react2.default.createElement(
            'option',
            { value: option.locale, key: pos },
            option.label
          );
        })
      );
    }
  }]);

  return LocaleSwitch;
}(_react.Component), _class.contextTypes = _extends({}, _LocaleProvider2.default.childContextTypes), _class.defaultProps = {
  setLocale: true
}, _class.propTypes = {
  locales: _react.PropTypes.array.isRequired,
  setLocale: _react.PropTypes.bool,
  disabled: _react.PropTypes.bool,
  name: _react.PropTypes.string,
  className: _react.PropTypes.string,
  onChange: _react.PropTypes.func,
  onError: _react.PropTypes.func
}, _temp);
exports.default = LocaleSwitch;